let DOM_ready = null;
Object.defineProperty(window, "DOM_ready", {
    value: new Promise(launched_function_when_DOM_ready => {
        DOM_ready = launched_function_when_DOM_ready;
    }), enumerable: false, configurable: false, writable: false
});
window.document.onreadystatechange = DOM_ready;

(window as any).DOM_ready.then(() => {
    const image = window.document.createElement('img');
    image.setAttribute('id', "night_sky");
    image.setAttribute('align', 'middle');
    window.document.body.appendChild(image);
});

const Firefox = Promise.resolve(window.navigator.userAgent.includes("Firefox"));
Firefox.then(result => {
//    if (result)
//        window.alert("Firefox");
});

const Chrome = Promise.resolve(window.navigator.userAgent.includes("Chrome"));
Chrome.then(result => {
//    if (result)
//        window.alert("Chrome");
});

const image = new Image();
const is_image_loaded = new Promise(send => {
    image.onload = () => {
        window.console.assert(image.complete);
        send(image.complete);
    };
});
image.src = "./img/Night_sky.jpg"; // Image load…

const is_image_loaded_in_less_than_100ms = new Promise((yes, no) => {
    window.setTimeout(() => no(new Error('more than 100ms')), 10); // Change to '1000' afterwards...
});

const who_wins = Promise.race([is_image_loaded, is_image_loaded_in_less_than_100ms]);
who_wins.then(image_complete => {
    // window.alert("Image complete: " + image_complete);
});
who_wins.catch(error => window.alert(error));

// 'fetch' API support at 'http://caniuse.com/#feat=fetch'
Promise.all([Promise.resolve(window.fetch !== undefined), (window as any).DOM_ready, window.fetch("./img/Night_sky.jpg").then((response: Response) => {
    return response.blob();
})]).then((parameters: Array<any>) => {
    // 'parameters[1]' guarantees that DOM is ready:
    const image = window.document.getElementById("night_sky") as HTMLImageElement;
    if (parameters[0] === true)  // 'fetch' API is supported by the browser
        // 'parameters[2]' -> Image is available (i.e., 'complete') and transformed into blob:
        image.src = URL.createObjectURL(parameters[2] as Blob); // 'image' is loaded from "./img/Night_sky.jpg"
});




